<?php

/*******************************************************************************/
//                          InstantCMS v1.8                                    //
//                      http://www.instantcms.ru/                              //
//                     API to http://nextgame.ru                               //
//                     written by Marat Fatikhov                               //
//                      (nickname  on a site)                             //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/



if(!defined('VALID_CMS')) { die('ACCESS DENIED'); }


define('API_SECRET_KEY','****************************************');
define('SITE_ID','***');

//     
function ErrorReply($code,$msg){
    $reply = '<?xml version="1.0" encoding="UTF-8"?><error><code>'.$code.'</code><msg>'.$msg.'</msg></error>';
    $reply = iconv('cp1251', 'utf-8', $reply);
    return $reply;
}


//   
function isSignatureValid (){
    $param = $_GET;//  
    $sig = $param['sig'];// 
    $line = '';
    unset($param['sig']);//   
    ksort($param);//   
    foreach ($param as $name => $value) {
        $line .= $name . '=' . $value;//   =
    }
    $line .= API_SECRET_KEY;//  -
   if ($sig == md5($line)) {// 
       return true;// 
   }else {
       return false;
   };
}

//    
function addServerSignature($url) {
    $param = '';
    parse_str(parse_url($url, PHP_URL_QUERY), $param);//     
    $line = '';
    ksort($param);
    foreach ($param as $name => $value) {
        $line .= $name . '=' . $value;//   =
    }
    $line .= API_SECRET_KEY;//  -
    $url .= '&sig=' . md5($line);//   
    return $url;
}

//      
function getLinkGame($user_id, $app_id ){
  $url = 'http://api2.nextgame.ru/iframe/js/link/?app_id='.$app_id.'&site_id='.SITE_ID.'&user_id='.$user_id ;
  $url =  addServerSignature($url);
  $code =  '<script type=\'text/javascript\' src=\''.$url.'\'></script>';
  return $code;
}

//      
function getLogoLinkGame($user_id, $app_id ){
    $url = 'http://api2.nextgame.ru/iframe/js/link/?app_id='.$app_id.'&site_id='.SITE_ID.'&user_id='.$user_id.'&linktype=1' ;
  $url =  addServerSignature($url);
  $code =  '<script type=\'text/javascript\' src=\''.$url.'\'></script>';
  return $code;
}

//    iframe
function getIframeGame($user_id, $app_id ){
    $url = 'http://api2.nextgame.ru/iframe/js/?app_id='.$app_id.'&site_id='.SITE_ID.'&user_id='.$user_id ;
  $url =  addServerSignature($url);
  $code =  '<script type=\'text/javascript\' src=\''.$url.'\'></script>';
  return $code;
}

?>
